/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
$("#navBar").hide();
var lat, lnglat, acc;
var err = "";
var nearby, low95, lowD, lowE;
var div;
var landcode;
var posType = 1;
var b = $('#refreshBtn');
var bL = $('#refreshBtnL');
var currentPage;
var adSecond = 1;


var app = {
    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function () {
        //app.receivedEvent('deviceready');
        $("#navBar").hide();
        $("#demo").html("");
        
        if(currentPage == "N" || typeof currentPage === 'undefined' || currentPage == null) {
            $("#demo").html($.mobile.loading('show'));
        } else {
            $("#demo2").html($.mobile.loading('show'));
        }

        
        if (app.checkNetworkConnection()) {
            //onDocLoad();
            //onResize();
            app.checkLocation();
        } else {
            document.getElementById('demo').innerHTML = "No network connection!";
            //$(document.body).html("No network connection!");
            //$("#demo").html($.mobile.hidePageLoadingMsg());
        }
    },
    // Update DOM on a Received Event
    receivedEvent: function (id) {

    },
    //Check Network connection
    checkNetworkConnection: function () {
        var networkState = navigator.connection.type;
        console.log("networstate: " + networkState);

        var states = {};
        states[Connection.UNKNOWN] = 'Unknown connection';
        states[Connection.ETHERNET] = 'Ethernet connection';
        states[Connection.WIFI] = 'WiFi connection';
        states[Connection.CELL_2G] = 'Cell 2G connection';
        states[Connection.CELL_3G] = 'Cell 3G connection';
        states[Connection.CELL_4G] = 'Cell 4G connection';
        states[Connection.CELL] = 'Cell generic connection';
        states[Connection.NONE] = 'No network connection';

        if (states[networkState] != "No network connection") {
            return true;
            //document.getElementById(id).innerHTML += "No network connection!";
        } else {
            return false;
            //check
        }
    },
    checkLocation: function () {
       var options = {timeout: 9000};
        navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
    }
};

function onSuccess(position) {
    lat = position.coords.latitude;
    lnglat = position.coords.longitude;
    posType = 1;
    var url = "http://maps.googleapis.com/maps/api/geocode/json?latlng=" + lat + "," + lnglat + "&sensor=true&language=NO";
    var country;
    document.getElementById('demo2').innerHTML = "";
    $.getJSON(url, function (data) {
              for (var i = 0; i < data.results.length; i++) {
              country = data.results[i].formatted_address;
              }
              
              if (typeof country != 'undefined' || country != null) {
              if (country.toLowerCase() == "sverige") {
              landcode = "SE";
              } else {
              landcode = "NO";
              }
              }
              getFullData();
              });
}

function onError(error) {
    
    posType = 0;
    err = '<div class="alert-box warning"><span>warning: </span>Turn on location/gps! ' + error.message + '</div>';
    
    $.getJSON("http://devextech.com/test.php",
              function(json) {
              landcode = json.country_code;
              document.getElemery;
              
              if(landcode != "SE" && landcode != "NO")
              {
              landcode = "NO"
              }
              
              lat = json.latitude;
              lnglat = json.longitude;
              getFullData();
              }
              );
}

function getFullData() {
    var element = document.getElementById('demo');
    if(landcode != null || typeof landcode != 'undefined') {
        getBody();
        /*
         var fuelUpdateAct = $("#fuelNav").find('.ui-btn-active').text();
         if (fuelUpdateAct == "Diesel") {
         getLowest("D");
         } else if(fuelUpdateAct == "E85") {
         getLowest("E");
         }*/
        getNearby();
    } else {
        element.innerHTML = ("Country code is undefined.");
        document.getElementById('demo2').innerHTML = ("Country code is undefined.");
        //$("#demo").html($.mobile.loading('hide'));
    }
}

function getBody() {
	if(landcode == "SE") {
		$("#headerNearby").html("N&auml;rmast");
        //$(".refreshBtn").append('<a id="refreshBtnTxt" href="#" data-icon="refresh" class="ui-btn-right" data-theme="b" onclick="refresh()">Uppdatera</a>');
        
        b.text('Uppdatera');
        b.buttonMarkup({ icon: "refresh" });
        bL.text('Uppdatera');
        bL.buttonMarkup({ icon: "refresh" });
        //$('#refreshBtnL').button();
        //$(".refreshBtn").button('refresh');
        
		$("#footerNearbyText").html("N&auml;rmast");
		$("#footerLowestText").html("Billigast");
		$("#headerLowest").html("Billigast");
		$("#LfooterNearbyText").html("N&auml;rmast");
		$("#LfooterLowestText").html("Billigast");
		$("#headerStaion").html("Station");
		$("#SfooterNearbyText").html("N&auml;rmast");
		$("#SfooterLowestText").html("Billigast");
		$("#backButton").html("Tillbaka");
	}
    if(landcode == "NO") {
        document.getElementById('demo').innerHTML = "";
		$("#headerNearby").html("N&aelig;rmest");
        
        //$(".refreshBtn").append('<a href="#" data-icon="refresh" class="ui-btn-right" data-theme="b" onclick="refresh()">Oppdater</a>');
        //$(".refreshBtn").append('<button class="ui-btn-right ui-btn ui-btn-b ui-btn-inline ui-mini ui-corner-all ui-btn-icon-right ui-icon-check" onclick="refresh()>Save</button>');
        //$(".refreshBtn").html("oppd");
        
        b.text('Oppdater');
        b.buttonMarkup({ icon: "refresh" });
        bL.buttonMarkup({ icon: "refresh" });
        bL.text('Oppdater');
        
        //$('#refreshBtnL').button();
        //$(".refreshBtn").button('refresh');
        
		$("#headerNearby").html("N&aelig;rmest");
		$("#footerNearbyText").html("N&aelig;rmest");
		$("#footerLowestText").html("Billigst");
		$("#headerLowest").html("Billigst");
        
		$("#e85Button").remove();
		$("#LfooterNearbyText").html("N&aelig;rmest");
		$("#LfooterLowestText").html("Billigst");
		$("#headerStaion").html("Stasjon");
        
		$("#SfooterNearbyText").html("N&aelig;rmest");
		$("#SfooterLowestText").html("Billigst");
		$("#backButton").html("Tilbake");
	}
}

function getNearby() {
	div = "#demo";
    $("#navBar").show();
    $("#nearbyBtn").addClass("ui-btn-active");
	if(typeof nearby === 'undefined' || nearby == null) {
        
		$.ajax({
               method: "POST",
               url: "http://devextech.com/dst/backend/nearby.php",
               data: { latlng: lat + "," + lnglat, landcode: landcode }
               })
        .done(function( data ) {
              $("#demo").html(err + data);
              $('#demo').listview().listview('refresh');
              $("#navBar").show();
              b.button('refresh');
              nearby = err + data;
              //$("#demo").html($.mobile.loading('hide'));
              });
        if(typeof low95 === 'undefined' || low95 == null  || lowD === 'undefined' || lowD == null) {
            doInBackground();
        }
	} else {
		$(div).html(nearby);
		$(div).listview('refresh');
	}
    
    
}

function doInBackground() {
	getLowest("B");
	getLowest("D");
	if(landcode == "SE") {
		getLowest("E");
	}
}

function stationDetail(station, time) {
	$("#stationData").html("");
    
	$.ajax({
           method: "POST",
           url: "http://devextech.com/dst/backend/station.php",
           data: { id: station, latlng: lat + ","	+ lnglat, landcode: landcode, status: time, posType: posType}
           })
    .done(function( data ) {
          $("#stationData").html(data);
          $("#stationData").selectmenu('refresh');
          });
	
    $(document).ready(function(){
                      $('.show-page-loading-msg').disableSelection();
                      });
    
    // This jQuery Plugin will disable text selection for Android and iOS devices.
    $.fn.extend({
                disableSelection: function() {
                this.each(function() {
                          this.onselectstart = function() {
                          return false;
                          };
                          this.unselectable = "on";
                          $(this).css('-moz-user-select', 'none');
                          $(this).css('-webkit-user-select', 'none');
                          });
                }
                });
    
    if(adSecond == 2)
    {
        AdMob.showInterstitial();
    }
    
    adSecond = 2;
    
}

function getLowest(fuel) {
    div = "#demo2";
    $("#navBarL").show();
    $("#lowestBtnL").addClass("ui-btn-active");
    if (typeof low95 === 'undefined' || low95 == null) {
        
        $.ajax({
               method: "POST",
               url: "http://devextech.com/dst/backend/lowest.php",
               data: {fuel: fuel, latlng: lat + "," + lnglat, landcode: landcode}
               })
        .done(function (data) {
              if (fuel == "B") {
              low95 = data;
              } else if (fuel == "D") {
              lowD = data;
              } else if (fuel == "E") {
              lowE = data;
              }
              
              if ($("#fuelNav").find('.ui-btn-active').text() == "B95") {
              
              $("#demo2").html(low95);
              $("#demo2").listview('refresh');
              
              $("#b95Button").addClass("ui-btn-active");
              $("#dieselButton").removeClass("ui-btn-active");
              $("#e85ButtonH").removeClass("ui-btn-active");
              //$("#demo2").html($.mobile.loading('hide'));
              
              } else if ($("#fuelNav").find('.ui-btn-active').text() == "Diesel") {
              $("#demo2").html(lowD);
              $("#demo2").listview('refresh');
              
              $("#b95Button").removeClass("ui-btn-active");
              $("#dieselButton").addClass("ui-btn-active");
              $("#e85ButtonH").removeClass("ui-btn-active");
              //$("#demo2").html($.mobile.loading('hide'));
              
              } else if ($("#fuelNav").find('.ui-btn-active').text() == "E85") {
              $("#demo2").html(lowE);
              $("#demo2").listview('refresh');
              
              $("#b95Button").removeClass("ui-btn-active");
              $("#dieselButton").removeClass("ui-btn-active");
              $("#e85ButtonH").addClass("ui-btn-active");
              //$("#demo2").html($.mobile.loading('hide'));
              
              }
              
              });
        
        
    } else {
        $.mobile.silentScroll(0);
        if (fuel == "B") {
            $(div).html(low95);
            $(div).listview('refresh');
            $("#b95Button").addClass("ui-btn-active");
            $("#dieselButton").removeClass("ui-btn-active");
            $("#e85ButtonH").removeClass("ui-btn-active");
            bL.button('refresh');
        } else if (fuel == "D") {
            $(div).html(lowD);
            $(div).listview('refresh');
            $("#b95Button").removeClass("ui-btn-active");
            $("#dieselButton").addClass("ui-btn-active");
            $("#e85ButtonH").removeClass("ui-btn-active");
        } else if (fuel == "E") {
            $(div).html(lowE);
            $(div).listview('refresh');
            $("#b95Button").removeClass("ui-btn-active");
            $("#dieselButton").removeClass("ui-btn-active");
            $("#e85ButtonH").addClass("ui-btn-active");
        }
        
    }
    
}

function refresh(page) {
    $("#demo").html("");
    $("#demo2").html("");
    //$("#demo").html($.mobile.loading('show'));
    $("#navBarL").hide();
    $("#navBar").hide();
    currentPage = page;
    
    lat = null, lnglat = null, nearby = null, low95 = null, lowD = null, lowE = null, err = "";
    
    app.initialize();
    //var options = {timeout: 7000};
    //navigator.geolocation.getCurrentPosition(onSuccess, onError, options);
}

app.initialize();


//Admob
var admobid = {};

// TODO: replace the following ad units with your own
if (/(android)/i.test(navigator.userAgent)) {
    admobid = { // for Android
        banner: 'ca-app-pub-8269119161564991/4057294469'
        , interstitial: 'ca-app-pub-8269119161564991/8962048465'
    };
}

function initApp() {
    if (!AdMob) {
        alert('admob plugin not ready');
        return;
    }
    
    AdMob.prepareInterstitial( {adId:admobid.interstitial, autoShow:false, isTesting: false} );
    //AdMob.showInterstitial();
    

    // this will create a banner on startup
    AdMob.createBanner({
        adId: admobid.banner
        , position: AdMob.AD_POSITION.BOTTOM_CENTER
        , isTesting: false, // TODO: remove this line when release
        overlap: false
        , offsetTopBar: false
        , bgColor: 'black'
    });
    
    
}

if ((/(ipad|iphone|ipod|android|windows phone)/i.test(navigator.userAgent))) {
    document.addEventListener('deviceready', initApp, false);
} else {
    initApp();
}